diff a/test/micro/org/openjdk/bench/valhalla/acmp/array/InlineIsCmpBranch64long.java b/test/micro/org/openjdk/bench/valhalla/acmp/array/InlineIsCmpBranch64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/array/InlineIsCmpBranch64long.java
@@ -0,0 +1,347 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.array;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.OperationsPerInvocation;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@Fork(3)
+@Warmup(iterations = 3, time = 1)
+@Measurement(iterations = 5, time = 1)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@BenchmarkMode(Mode.AverageTime)
+@State(Scope.Thread)
+public class InlineIsCmpBranch64long extends StatesQ64long {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Obj(Object[] objects1, Object[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i] == objects2[i]) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Int(Int64[] objects1, Int64[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i] == objects2[i]) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Ref(Q64long[] objects1, Q64long[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i] == objects2[i]) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    private static int cmp_Val(Q64long[] objects1, Q64long[] objects2) {
+        int s = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (objects1[i] == objects2[i]) {
+                s += 1;
+            } else {
+                s -= 1;
+            }
+        }
+        return s;
+    }
+
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals000(ObjState00 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals025(ObjState25 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals050(ObjState50 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals075(ObjState75 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Obj_equals100(ObjState100 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals000(IntState00 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals025(IntState25 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals050(IntState50 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals075(IntState75 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Int_equals100(IntState100 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals000(RefState00 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals025(RefState25 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals050(RefState50 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals075(RefState75 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Ref_equals100(RefState100 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals000(ValState00 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals025(ValState25 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals050(ValState50 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals075(ValState75 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_equals100(ValState100 st) {
+        return cmp_Val(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Ref_equals000(ValState00 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Ref_equals025(ValState25 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Ref_equals050(ValState50 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Ref_equals075(ValState75 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Ref_equals100(ValState100 st) {
+        return cmp_Ref(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Int_equals000(ValState00 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Int_equals025(ValState25 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Int_equals050(ValState50 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Int_equals075(ValState75 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Int_equals100(ValState100 st) {
+        return cmp_Int(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Obj_equals000(ValState00 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Obj_equals025(ValState25 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Obj_equals050(ValState50 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Obj_equals075(ValState75 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+    @Benchmark
+    @OperationsPerInvocation(SIZE)
+    @CompilerControl(CompilerControl.Mode.INLINE)
+    public int Val_as_Obj_equals100(ValState100 st) {
+        return cmp_Obj(st.arr1, st.arr2);
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesQ64byte.java b/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesQ64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesQ64byte.java
@@ -0,0 +1,261 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.array;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+
+import java.util.BitSet;
+import java.util.Random;
+
+public class StatesQ64byte {
+
+    public static final int SIZE = 100;
+
+    private static BitSet indices(Random rnd, int bound, int size) {
+        return rnd.ints(0, bound)
+                .distinct()
+                .limit(size)
+                .collect(BitSet::new, BitSet::set, BitSet::or);
+    }
+
+    private static void populate(Object[] arr1, Object[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                arr2[i] = arr1[i] = new Q64byte(i);
+            } else {
+                arr1[i] = new Q64byte(2 * i);
+                arr2[i] = new Q64byte(2 * i + 1);
+            }
+        }
+    }
+
+    @State(Scope.Thread)
+    public abstract static class ObjState {
+        Object[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class IntState {
+        Int64[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class RefState {
+        Q64byte[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class ValState {
+        Q64byte[] arr1, arr2;
+    }
+
+    public static class ObjState00 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 0);
+        }
+
+    }
+
+    public static class ObjState25 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 25);
+        }
+
+    }
+
+    public static class ObjState50 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 50);
+        }
+
+    }
+
+    public static class ObjState75 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 75);
+        }
+
+    }
+
+    public static class ObjState100 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class IntState00 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class IntState25 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class IntState50 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class IntState75 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class IntState100 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class RefState00 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class RefState25 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class RefState50 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class RefState75 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class RefState100 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class ValState00 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class ValState25 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class ValState50 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class ValState75 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class ValState100 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64byte[SIZE];
+            arr2 = new Q64byte[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesQ64long.java b/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesQ64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesQ64long.java
@@ -0,0 +1,261 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.array;
+
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+
+import java.util.BitSet;
+import java.util.Random;
+
+public class StatesQ64long {
+
+    public static final int SIZE = 100;
+
+    private static BitSet indices(Random rnd, int bound, int size) {
+        return rnd.ints(0, bound)
+                .distinct()
+                .limit(size)
+                .collect(BitSet::new, BitSet::set, BitSet::or);
+    }
+
+    private static void populate(Object[] arr1, Object[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                arr2[i] = arr1[i] = new Q64long(i);
+            } else {
+                arr1[i] = new Q64long(2 * i);
+                arr2[i] = new Q64long(2 * i + 1);
+            }
+        }
+    }
+
+    @State(Scope.Thread)
+    public abstract static class ObjState {
+        Object[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class IntState {
+        Int64[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class RefState {
+        Q64long[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class ValState {
+        Q64long[] arr1, arr2;
+    }
+
+    public static class ObjState00 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 0);
+        }
+
+    }
+
+    public static class ObjState25 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 25);
+        }
+
+    }
+
+    public static class ObjState50 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 50);
+        }
+
+    }
+
+    public static class ObjState75 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 75);
+        }
+
+    }
+
+    public static class ObjState100 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class IntState00 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class IntState25 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class IntState50 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class IntState75 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class IntState100 extends IntState {
+        @Setup
+        public void setup() {
+            arr1 = new Int64[SIZE];
+            arr2 = new Int64[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class RefState00 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class RefState25 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class RefState50 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class RefState75 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class RefState100 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class ValState00 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class ValState25 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class ValState50 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class ValState75 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class ValState100 extends ValState {
+        @Setup
+        public void setup() {
+            arr1 = new Q64long[SIZE];
+            arr2 = new Q64long[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesR64long.java b/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesR64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/acmp/array/StatesR64long.java
@@ -0,0 +1,178 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.acmp.array;
+
+import org.openjdk.bench.valhalla.types.R64long;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.State;
+
+import java.util.BitSet;
+import java.util.Random;
+
+public class StatesR64long {
+
+    public static final int SIZE = 100;
+
+    private static BitSet indices(Random rnd, int bound, int size) {
+        return rnd.ints(0, bound)
+                .distinct()
+                .limit(size)
+                .collect(BitSet::new, BitSet::set, BitSet::or);
+    }
+
+    private static void populate(Object[] arr1, Object[] arr2, int eq) {
+        BitSet eqset = (eq > 0 && eq < 100) ? indices(new Random(42), SIZE, (eq * SIZE) / 100) : null;
+        int samenulls = 0;
+        int distinctnulls = 0;
+        for (int i = 0; i < SIZE; i++) {
+            if (eq > 0 && (eq >= 100 || eqset.get(i))) {
+                if (samenulls > 0) {
+                    arr2[i] = arr1[i] = new R64long(i);
+                } else {
+                    arr2[i] = arr1[i] = null;
+                    samenulls++;
+                }
+            } else {
+                if (distinctnulls > 1) {
+                    arr1[i] = new R64long(2 * i);
+                    arr2[i] = new R64long(2 * i + 1);
+                } else {
+                    if (distinctnulls == 0) {
+                        arr1[i] = null;
+                        arr2[i] = new R64long(2 * i + 1);
+                    } else {
+                        arr1[i] = new R64long(2 * i);
+                        arr2[i] = null;
+                    }
+                    distinctnulls++;
+                }
+            }
+        }
+    }
+
+    @State(Scope.Thread)
+    public abstract static class ObjState {
+        Object[] arr1, arr2;
+    }
+
+    @State(Scope.Thread)
+    public abstract static class RefState {
+        R64long[] arr1, arr2;
+    }
+
+    public static class ObjState00 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 0);
+        }
+
+    }
+
+    public static class ObjState25 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 25);
+        }
+
+    }
+
+    public static class ObjState50 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 50);
+        }
+
+    }
+
+    public static class ObjState75 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 75);
+        }
+
+    }
+
+    public static class ObjState100 extends ObjState {
+        @Setup
+        public void setup() {
+            arr1 = new Object[SIZE];
+            arr2 = new Object[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+    public static class RefState00 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new R64long[SIZE];
+            arr2 = new R64long[SIZE];
+            populate(arr1, arr2, 0);
+        }
+    }
+
+    public static class RefState25 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new R64long[SIZE];
+            arr2 = new R64long[SIZE];
+            populate(arr1, arr2, 25);
+        }
+    }
+
+    public static class RefState50 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new R64long[SIZE];
+            arr2 = new R64long[SIZE];
+            populate(arr1, arr2, 50);
+        }
+    }
+
+    public static class RefState75 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new R64long[SIZE];
+            arr2 = new R64long[SIZE];
+            populate(arr1, arr2, 75);
+        }
+    }
+
+    public static class RefState100 extends RefState {
+        @Setup
+        public void setup() {
+            arr1 = new R64long[SIZE];
+            arr2 = new R64long[SIZE];
+            populate(arr1, arr2, 100);
+        }
+    }
+
+}
